Imports System
Imports GTA
Imports System.Windows.Forms
Imports System.IO

Public Class Prone
    Inherits Script
    Private prone As New AnimationSet("misskbtruck")
    Private getUp As New AnimationSet("get_up")
    Private isAiming As Boolean = False
    Public isProne As Boolean = False
    Public isCrawling As Boolean = False
    Public veh As Vehicle

    Sub New()
        Settings.Load()
        BindKey(Settings.GetValueKey("Toggle Prone", "SETTINGS", Keys.Z), New KeyPressDelegate(AddressOf toggleProne))
        BindKey(Settings.GetValueKey("Roll Left", "SETTINGS", Keys.Q), New KeyPressDelegate(AddressOf rollLeft))
        BindKey(Settings.GetValueKey("Roll Right", "SETTINGS", Keys.E), New KeyPressDelegate(AddressOf rollRight))
        BindKey(Settings.GetValueKey("Free View", "SETTINGS", Keys.Space), New KeyPressDelegate(AddressOf freeView))
        Me.Interval = 10
    End Sub

    Private Sub cameraTrack() Handles MyBase.Tick
        If isProne Then
            If Not Game.isKeyPressed(Settings.GetValueKey("Free View", "SETTINGS", Keys.Space)) AndAlso Not isAiming Then
                Player.Character.Heading = Game.CurrentCamera.Heading
            End If

            If Game.isGameKeyPressed(GameKey.Sprint) Then
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_fwd_loop", 1.0)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_slide_left", 0.5)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_slide_right", 0.5)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_roll_left", 0.8)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_roll_right", 0.8)
            Else
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_fwd_loop", 2.2)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_slide_left", 1.0)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_slide_right", 1.0)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_roll_left", 1.5)
                GTA.Native.Function.Call("SET_CHAR_ANIM_SPEED", Player.Character, "misskbtruck", "crawl_roll_right", 1.5)
            End If

            If GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
                If Not GTA.Native.Function.Call(Of Boolean)("IS_CHAR_DUCKING", Player.Character) Then
                    GTA.Native.Function.Call("SET_CHAR_DUCKING", Player.Character, True)
                End If
                If exists(veh) Then
                    If veh.isupsidedown OrElse Not veh.isalive Then
                        toggleProne()
                    End If
                End If
            End If

            If player.character.isragdoll Then
                isprone = False
                If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_DUCKING", Player.Character) Then
                    GTA.Native.Function.Call("SET_CHAR_DUCKING", Player.Character, False)
                End If
            End If
        End If
    End Sub

    Private Sub aim(ByVal sender As Object, ByVal e As GTA.MouseEventArgs) Handles MyBase.MouseDown
        If e.Button <> MouseButtons.Right Then Return
        If isProne Then
            If Not Player.Character.Weapons.Current = Weapon.Unarmed Then
                If Not isCrawling AndAlso Not isAiming Then
                    If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_left") Then
                        Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                        GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_left", tmpTime)
                        If tmpTime.Value = 1 Then
                            isAiming = True
                            Player.Character.Animation.Play(prone, "", 1.0)
                        End If
                    ElseIf GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_right") Then
                        Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                        GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_right", tmpTime)
                        If tmpTime.Value = 1 Then
                            isAiming = True
                            Player.Character.Animation.Play(prone, "", 1.0)
                        End If
                    Else
                        isAiming = True
                        Player.Character.Animation.Play(prone, "", 1.0)
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub cancelAim(ByVal sender As Object, ByVal e As GTA.MouseEventArgs) Handles MyBase.MouseUp
        If e.Button <> MouseButtons.Right Then Return
        If isProne AndAlso Not isCrawling Then
            If isAiming Then
                isAiming = False
                If Not GTA.Native.Function.Call(Of Boolean)("IS_CHAR_DUCKING", Player.Character) AndAlso Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
                    isProne = False
                Else
                    GTA.Native.Function.Call("SET_CHAR_DUCKING", Player.Character, True)
                    Player.Character.Animation.Play(prone, "crawl_idle", 3.5F, AnimationFlags.Unknown05)
                End If
            End If
        End If
    End Sub

    Private Sub toggleProne()
        If Not Player.Character.isInVehicle Then
            veh = World.GetClosestVehicle(Player.Character.Position, 4.0)
            Dim vehH As Single

            If Exists(veh) Then
                Dim vehPos As Vector3
                vehPos = veh.Position
                vehH = GTA.Native.Function.Call(Of Single)("GET_HEIGHT_OF_VEHICLE", veh, vehPos.X, vehPos.Y, vehPos.Z, True, False)
            End If

            If Not isProne Then
                If Player.Character.isIdle OrElse GTA.Native.Function.Call(Of Boolean)("IS_CHAR_DUCKING", Player.Character) Then
                    If Not Player.Character.isGettingUp Then
                        If Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
                            If Exists(veh) Then
                                Dim vehM As GTA.Model = veh.Model
                                If Not Native.Function.Call(Of Boolean)("IS_THIS_MODEL_A_BIKE", vehM) AndAlso Not Native.Function.Call(Of Boolean)("IS_THIS_MODEL_A_BOAT", vehM) AndAlso Not Native.Function.Call(Of Boolean)("IS_THIS_MODEL_A_HELI", vehM) AndAlso Not Native.Function.Call(Of Boolean)("IS_THIS_MODEL_A_PLANE", vehM) AndAlso Not Native.Function.Call(Of Boolean)("IS_THIS_MODEL_A_TRAIN", vehM) Then
                                    If Player.Character.Position.Z > veh.Position.Z + 1 AndAlso veh.isUpright AndAlso veh.isAlive AndAlso veh.isOnAllWheels Then
                                        Dim tempOffset As Vector3 = Player.Character.Position
                                        tempOffset.X = 0
                                        tempOffset.Y = -0.5
                                        tempOffset.Z = vehH + 1.1
                                        Player.Character.AttachTo(veh, tempOffset)
                                    End If
                                End If
                            End If
                        End If

                        isProne = True
                        Player.Character.Task.ClearAll()
                        GTA.Native.Function.Call("SET_CHAR_DUCKING", Player.Character, True)
                        Player.Character.Animation.Play(prone, "crawl_idle", 3.5F, AnimationFlags.Unknown05)
                    End If
                End If
            Else
                If GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) AndAlso Not isAiming Then
                    Player.Character.Detach()

                    If Exists(veh) Then
                        Dim vehOP As Vector3
                        vehOP = veh.GetOffsetPosition(New Vector3(2.5F, 0.0F, 0.0F))
                        Player.TeleportTo(vehOP)
                    Else
                        Dim pos As Vector3 = Player.Character.Position
                        pos.X = Player.Character.Position.X + 3
                        pos.Z = Player.Character.Position.Z - 1
                        Player.TeleportTo(pos)
                    End If
                End If

                If isAiming Then
                    isAiming = False
                    Player.Character.Animation.Play(prone, "crawl_idle", 3.5F, AnimationFlags.Unknown05)

                    If Not GTA.Native.Function.Call(Of Boolean)("IS_CHAR_DUCKING", Player.Character) Then
                        GTA.Native.Function.Call("SET_CHAR_DUCKING", Player.Character, True)
                    End If
                Else
                    isProne = False
                    GTA.Native.Function.Call("SET_CHAR_DUCKING", Player.Character, False)

                    If Player.Character.Health > 50 Then
                        Player.Character.Animation.Play(getUp, "get_up_fast", 10.0F, AnimationFlags.Unknown01)
                    Else
                        Player.Character.Animation.Play(getUp, "get_up_normal", 10.0F, AnimationFlags.Unknown01)
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub crawlForward(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown
        If e.Key <> Keys.W Then Return
        If isProne AndAlso Not isCrawling AndAlso Not isAiming AndAlso Not Game.isKeyPressed(Keys.A) AndAlso Not Game.isKeyPressed(Keys.D) AndAlso Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
            If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_left") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_left", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_fwd_loop", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                    isCrawling = True
                End If
            ElseIf GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_right") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_right", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_fwd_loop", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                    isCrawling = True
                End If
            Else
                Player.Character.Animation.Play(prone, "crawl_fwd_loop", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                isCrawling = True
            End If
        End If
    End Sub

    Private Sub crawlLeft(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown
        If e.Key <> Keys.A Then Return
        If isProne AndAlso Not isCrawling AndAlso Not isAiming AndAlso Not Game.isKeyPressed(Keys.D) AndAlso Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
            If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_left") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_left", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_slide_left", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                    isCrawling = True
                End If
            ElseIf GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_right") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_right", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_slide_left", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                    isCrawling = True
                End If
            Else
                Player.Character.Animation.Play(prone, "crawl_slide_left", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                isCrawling = True
            End If
        End If
    End Sub

    Private Sub crawlRight(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyDown
        If e.Key <> Keys.D Then Return
        If isProne AndAlso Not isCrawling AndAlso Not isAiming AndAlso Not Game.isKeyPressed(Keys.A) AndAlso Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
            If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_left") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_left", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_slide_right", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                    isCrawling = True
                End If
            ElseIf GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_right") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_right", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_slide_right", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                    isCrawling = True
                End If
            Else
                Player.Character.Animation.Play(prone, "crawl_slide_right", 10.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                isCrawling = True
            End If
        End If
    End Sub

    Private Sub rollLeft()
        If isProne AndAlso Not isCrawling AndAlso Not isAiming AndAlso Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
            If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_left") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_left", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_roll_left", 10.0F, AnimationFlags.Unknown06 Or AnimationFlags.Unknown01)
                End If
            ElseIf GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_right") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_right", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_roll_left", 10.0F, AnimationFlags.Unknown06 Or AnimationFlags.Unknown01)
                End If
            Else
                Player.Character.Animation.Play(prone, "crawl_roll_left", 10.0F, AnimationFlags.Unknown06 Or AnimationFlags.Unknown01)
            End If
        End If
    End Sub

    Private Sub rollRight()
        If isProne AndAlso Not isCrawling AndAlso Not isAiming AndAlso Not GTA.Native.Function.Call(Of Boolean)("IS_PED_ATTACHED_TO_ANY_CAR", Player.Character) Then
            If GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_left") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_left", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_roll_right", 10.0F, AnimationFlags.Unknown06 Or AnimationFlags.Unknown01)
                End If
            ElseIf GTA.Native.Function.Call(Of Boolean)("IS_CHAR_PLAYING_ANIM", Player.Character, "misskbtruck", "crawl_roll_right") Then
                Dim tmpTime As Native.Pointer = New Native.Pointer(GetType(Single))
                GTA.Native.Function.Call("GET_CHAR_ANIM_CURRENT_TIME", Player.Character, "misskbtruck", "crawl_roll_right", tmpTime)
                If tmpTime.Value = 1 Then
                    Player.Character.Animation.Play(prone, "crawl_roll_right", 10.0F, AnimationFlags.Unknown06 Or AnimationFlags.Unknown01)
                End If
            Else
                Player.Character.Animation.Play(prone, "crawl_roll_right", 10.0F, AnimationFlags.Unknown06 Or AnimationFlags.Unknown01)
            End If
        End If
    End Sub

    Private Sub stopCrawl(ByVal sender As Object, ByVal e As GTA.KeyEventArgs) Handles MyBase.KeyUp
        If e.Key = Keys.W OrElse e.Key = Keys.A OrElse e.Key = Keys.D OrElse e.Key = Keys.S Then
            If isProne AndAlso isCrawling AndAlso Not Game.isKeyPressed(Keys.A) AndAlso Not Game.isKeyPressed(Keys.D) AndAlso Not Game.isKeyPressed(Keys.W) Then
                Player.Character.Animation.Play(prone, "crawl_idle", 5.0F, AnimationFlags.Unknown05 Or AnimationFlags.Unknown01)
                isCrawling = False
            End If
        End If
    End Sub

    Private Sub freeView()
    End Sub

End Class